package com.isv;

/**
 * Insert the type's description here.
 * Creation date: (2/7/2001 5:22:42 PM)
 * @author: 
 */
import java.io.*;
import java.awt.*;
import javax.swing.*;
//import javax.swing.text.*;
import java.util.*;
import java.beans.*;
import org.w3c.dom.*;
public class PasswordPropertyEditor extends javax.swing.text.PlainDocument implements java.beans.PropertyEditor{
	FileWriter logFile = null;
	JPasswordField jpf = null;
	Vector propertyChangeListeners = new Vector();
	Element element = null;
/**
 * PasswordPropertyEditor constructor comment.
 */
public PasswordPropertyEditor() {
	super();
	log(">> PasswordPropertyEditor");
	if (jpf == null)
	{
		jpf = new JPasswordField(10);
		jpf.setDocument(this);
	}
}
/**
	 * Register a listener for the PropertyChange event.  When a
	 * PropertyEditor changes its value it should fire a PropertyChange
	 * event on all registered PropertyChangeListeners, specifying the
	 * null value for the property name and itself as the source.
	 *
	 * @param listener  An object to be invoked when a PropertyChange
	 *event is fired.
	 */
public void addPropertyChangeListener(
	java.beans.PropertyChangeListener listener)
{
	log(">> addPropertyChangeListener()");
	propertyChangeListeners.addElement(listener);
	if (jpf == null)
	{
	}
}
/**
	 * Gets the property value as text.
	 * 
	 * @return The property value as a human editable string.
	 * <p>   Returns null if the value can't be expressed as an editable string.
	 * <p>   If a non-null value is returned, then the PropertyEditor should
	 *     be prepared to parse that string back in setAsText().
	 */
public String getAsText()
{
	String password = new String(jpf.getPassword());
	log(">> getAsText");
	log(">>    Returning: \"" + password + "\"");
	if (element != null)
	{
		element.setAttribute("value", password);
	}
	return password;
	//return null;
}
/**
	 * A PropertyEditor may choose to make available a full custom Component
	 * that edits its property value.  It is the responsibility of the
	 * PropertyEditor to hook itself up to its editor Component itself and
	 * to report property value changes by firing a PropertyChange event.
	 * <P>
	 * The higher-level code that calls getCustomEditor may either embed
	 * the Component in some larger property sheet, or it may put it in
	 * its own individual dialog, or ...
	 *
	 * @return A java.awt.Component that will allow a human to directly
	 *      edit the current property value.  May be null if this is
	 *    not supported.
	 */
public java.awt.Component getCustomEditor()
{
	log(">> getCustomEditor");
	
	return jpf;
}
/**
	 * This method is intended for use when generating Java code to set
	 * the value of the property.  It should return a fragment of Java code
	 * that can be used to initialize a variable with the current property
	 * value.
	 * <p>
	 * Example results are "2", "new Color(127,127,34)", "Color.orange", etc.
	 *
	 * @return A fragment of Java code representing an initializer for the
	 *   current value.
	 */
public String getJavaInitializationString()
{
	log(">> getJavaInitializationString");
	return null;
}
/**
	 * If the property value must be one of a set of known tagged values, 
	 * then this method should return an array of the tags.  This can
	 * be used to represent (for example) enum values.  If a PropertyEditor
	 * supports tags, then it should support the use of setAsText with
	 * a tag value as a way of setting the value and the use of getAsText
	 * to identify the current value.
	 *
	 * @return The tag values for this property.  May be null if this 
	 *   property cannot be represented as a tagged value.
	 *
	 */
public java.lang.String[] getTags()
{
	log(">> getTags()");
	return null;
}
/**
	 * Gets the property value.
	 *
	 * @return The value of the property.  Primitive types such as "int" will
	 * be wrapped as the corresponding object type such as "java.lang.Integer".
	 */
public Object getValue()
{
	log(">> getValue()");
	return element;
}
public void insertString(int offs, String str, javax.swing.text.AttributeSet a) throws javax.swing.text.BadLocationException
{

	super.insertString(offs, str, a);
	log(">> inserString()");
	String oldValue = element.getAttribute("value");
	element.setAttribute("value", new String(jpf.getPassword()));    
	notifyListeners(oldValue);	
}
/**
	 * Determines whether this property editor is paintable.
	 *
	 * @return  True if the class will honor the paintValue method.
	 */
public boolean isPaintable()
{
	log(">> isPaintable");
	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (2/7/2001 5:37:06 PM)
 * @param data java.lang.String
 */
public void log(String data)
{
	return;
	/*
	try
	{
		if (logFile == null)
		{
			logFile = new FileWriter("C:\\j.txt", true);
		}
		logFile.write(data + "\r\n");
		logFile.flush();
	}
	catch (Exception e)
	{
		System.out.println("Excpetion: " + e.toString());
	}
	*/
}
/**
 * Insert the method's description here.
 * Creation date: (2/7/2001 5:44:31 PM)
 * @param args java.lang.String[]
 */
public static void main(String[] args)
{
	PasswordPropertyEditor ppe = new PasswordPropertyEditor();
	ppe.log("Hellow world\n");
}
protected void notifyListeners(String oldValue)
{
	log(">> notifyListenere()");
	for (int idx = 0; idx < propertyChangeListeners.size(); idx++)
	{
		PropertyChangeEvent event = 
			new PropertyChangeEvent(
				this, 
				element.getAttribute("xmi.label"), 
				oldValue, 
				element.getAttribute("value")); 
		(
			(PropertyChangeListener) propertyChangeListeners.elementAt(
				idx)).propertyChange(
			event); 
	}
	log("<< notifyListeners()");
}
/**
	 * Paint a representation of the value into a given area of screen
	 * real estate.  Note that the propertyEditor is responsible for doing
	 * its own clipping so that it fits into the given rectangle.
	 * <p>
	 * If the PropertyEditor doesn't honor paint requests (see isPaintable)
	 * this method should be a silent noop.
	 * <p>
	 * The given Graphics object will have the default font, color, etc of
	 * the parent container.  The PropertyEditor may change graphics attributes
	 * such as font and color and doesn't need to restore the old values.
	 *
	 * @param gfx  Graphics object to paint into.
	 * @param box  Rectangle within graphics object into which we should paint.
	 */
public void paintValue(java.awt.Graphics gfx, java.awt.Rectangle box)
{
	log("paintValue()");
}
public void remove(int offs, int len)
	throws javax.swing.text.BadLocationException {

	super.remove(offs, len);
	log(">> remove()");
	String oldValue = null;
	oldValue = element.getAttribute("value");
	element.setAttribute("value", new String(jpf.getPassword()));    
	notifyListeners(oldValue);
}
/**
	 * Remove a listener for the PropertyChange event.
	 *
	 * @param listener  The PropertyChange listener to be removed.
	 */
public void removePropertyChangeListener(
	java.beans.PropertyChangeListener listener)
{
	log(">> removePropertyChangeListener()");
	propertyChangeListeners.removeElement(listener);
}
/**
	 * Set the property value by parsing a given String.  May raise
	 * java.lang.IllegalArgumentException if either the String is
	 * badly formatted or if this kind of property can't be expressed
	 * as text.
	 * @param text  The string to be parsed.
	 */
public void setAsText(String text) throws IllegalArgumentException {
	log(">> setAsText()");
	String oldValue = element.getAttribute("value");
	element.setAttribute("value", text);
	notifyListeners(oldValue);
}
/**
	 * Set (or change) the object that is to be edited.  Primitive types such
	 * as "int" must be wrapped as the corresponding object type such as
	 * "java.lang.Integer".
	 *
	 * @param value The new target object to be edited.  Note that this
	 *     object should not be modified by the PropertyEditor, rather 
	 *     the PropertyEditor should create a new object to hold any
	 *     modified value.
	 */
public void setValue(Object value)
{
	log(">> setValue()");
	String oldValue = null;
	if (element != null)
	{
		oldValue = element.getAttribute("value");
		log(">>    Old Value: " + oldValue);
	}
	
	element = (Element) value;
	if (element != null)
	{
		String temp = element.getAttribute("value");
		log("new value: " + temp);
		jpf.setText(temp);
	}
	notifyListeners(oldValue);
}
/**
	 * Determines whether this property editor supports a custom editor.
	 *
	 * @return  True if the propertyEditor can provide a custom editor.
	 */
public boolean supportsCustomEditor()
{
	log(">> supportsCustomEditor()");
	log(">>    Returning true");
	return true;
}
}
